Package io.vertx.rxjava3.ext.auth.authentication

## Interface Credentials

-     public interface Credentials

  Abstract representation of a Credentials object. All implementations of this interface will define the required types and parameters for the specific implementation.

  NOTE: This class has been automatically generated from the `original` non RX-ified interface using Vert.x codegen.

- - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `Credentials` | `applyHttpChallenge​(String challenge)` | Applies the HTTP Authorization challenge to this Credential instance.
    `Credentials` | `applyHttpChallenge​(String challenge, HttpMethod method, String uri)` | Applies the HTTP Authorization challenge to this Credential instance.
    `Credentials` | `applyHttpChallenge​(String challenge, HttpMethod method, String uri, Integer nc, String cnonce)` | Applies the HTTP Authorization challenge to this Credential instance.
    `<V> void` | `checkValid​(V arg)` | Implementors should override this method to perform validation.
    `Credentials` | `getDelegate()` |
    `static Credentials` | `newInstance​(Credentials arg)` |
    `String` | `toHttpAuthorization()` | Encodes this credential as an HTTP Authorization https://tools.ietf.org/html/rfc7235.
    `JsonObject` | `toJson()` | Simple interop to downcast back to JSON for backwards compatibility.

- - ### Method Detail

    - #### getDelegate

          Credentials getDelegate()

    - #### checkValid

          <V> void checkValid​(V arg)

      Implementors should override this method to perform validation. An argument is allowed to allow custom validation, for example, when given a configuration property, a specific property may be allowed to be null.
      Parameters:
        `arg` - optional argument or null.

    - #### toJson

          JsonObject toJson()

      Simple interop to downcast back to JSON for backwards compatibility.
      Returns:
        JSON representation of this credential.

    - #### applyHttpChallenge

          Credentials applyHttpChallenge​(String challenge,
                                         HttpMethod method,
                                         String uri,
                                         Integer nc,
                                         String cnonce)

      Applies the HTTP Authorization challenge to this Credential instance. The internal state can change to reflect the extra properties the challenge conveys.

      See https://tools.ietf.org/html/rfc7235 for more information.

      Parameters:
        `challenge` - the challenge is the `WWW-Authenticate` header response from a 401 request. Null challenges are allowed, and in this case, no verification will be performed, however it is up to the implementation to permit this.
        `method` - The http method this response is responding.
        `uri` - The http uri this response is responding.
        `nc` - The client internal counter (optional).
        `cnonce` - The client internal nonce (optional).
      Returns:
        fluent self.

    - #### applyHttpChallenge

          Credentials applyHttpChallenge​(String challenge,
                                         HttpMethod method,
                                         String uri)

      Applies the HTTP Authorization challenge to this Credential instance. The internal state can change to reflect the extra properties the challenge conveys.

      See https://tools.ietf.org/html/rfc7235 for more information.

      Parameters:
        `challenge` - the challenge is the `WWW-Authenticate` header response from a 401 request. Null challenges are allowed, and in this case, no verification will be performed, however it is up to the implementation to permit this.
        `method` - The http method this response is responding.
        `uri` - The http uri this response is responding.
      Returns:
        fluent self.

    - #### applyHttpChallenge

          Credentials applyHttpChallenge​(String challenge)

      Applies the HTTP Authorization challenge to this Credential instance. The internal state can change to reflect the extra properties the challenge conveys.

      See https://tools.ietf.org/html/rfc7235 for more information.

      Parameters:
        `challenge` - the challenge is the `WWW-Authenticate` header response from a 401 request. Null challenges are allowed, and in this case, no verification will be performed, however it is up to the implementation to permit this.
      Returns:
        fluent self.

    - #### toHttpAuthorization

          String toHttpAuthorization()

      Encodes this credential as an HTTP Authorization https://tools.ietf.org/html/rfc7235.

      Calls to this method, expect that `applyHttpChallenge(java.lang.String, io.vertx.core.http.HttpMethod, java.lang.String, java.lang.Integer, java.lang.String)` has been prior executed. For some Authentication schemes, this isn't a requirement but doing so ensures that the object is on the right state.

      Returns:
        HTTP header including scheme.

    - #### newInstance

          static Credentials newInstance​(Credentials arg)